# <div align="center"> **weiz*PVP***: *CHANGELOG* </div>

<div align="center">

Hosted on: [**Curse**](https://wow.curseforge.com/projects/weizpvp) *and* [**WoW Interface**](https://www.wowinterface.com/downloads/info24779-weizPVP.html)

</div>

## 📦 1.72.1

**CODE & BACKEND**
- **More Optimizations**:
	- More CPU and Memory Optimizations.
	- Faster initial addon loading.
	- Removal of yet another library which has been replaced a lot less code running much lighter.
- **New command added**:
	- `/wpvp ch` - Toggles Crosshairs on/off
- Embedded Libraries updated
- Improved saving and restoring of window position and size.
  - Changes should help those using scaled UI or switch between monitors using the same settings.
- *"Recent Changes"* splash screen has been worked on further:
	- Multiple small bugs fixed.
	- Will be properly checking for older versions from now on.

**INTERFACE & DESIGN**
- Stealth Alert updates and changes
	- Alert window has been reshaped; Much slimmer padding and it now uses 1 line of text instead of 2.
	- Stealth Alerts will now be displayed on the status bar, and for a longer time; more related options for this are coming.
	- Alert window visual updates.
- Crosshair Updates
	- Fixed the ordering of layers for a better look (part of the shadow was overlapping other elements before)
	- Name and Guild Text have come back as an option after being requested; Off by default.
- Added key binding:
  - 'Toggle Crosshairs' is the only option for now, after it was request. 
  - You can set this going to Key Bindings'' from the main menu and looking in the 'AddOns' category.
- Status Bar visual updates and a few fixes.
- Crosshairs:
  - Some image assets have been redone for Crosshairs. Higher resolution to improve sharpness when scaling off targeted nameplates.
  - Additional options added such as Line Thickness, Additional Visual FX, and Rotating Arrows.
- More tooltips added and update the text depending on conditions.
- Updated the fonts (Yes, that's a thing!
  - Better readability at smaller sizes, which is the case for the player bars at the moment.

**MEDIA ASSETS**
- There were some requests for a particular sound effect to be included, and so it shall be:
  - "MLG Air Horn" sound effect now included and will be available for any sound options.

----

## 📦 1.71.8

**CODE & BACKEND**
- Added more stealth/prowl/invis/etc detection!

----

## 📦 1.71.7

**CODE & BACKEND**
- Fixed a bug that let weizPVP run while in PVE raids and dungeons. It should now properly NOT run or show while in PVE instances.

----

## 📦 1.71.6

**CODE & BACKEND**
- Fixed an issue where the new version popup would still allow you to click the OK button after disappearing.


----

## 📦 1.71.5

**CODE & BACKEND**
- Some small optimizations done to Crosshairs.

----

## 📦 1.71.4

**CODE & BACKEND**
- Crosshairs toggling back to enabled bug fixed.

----

## 📦 1.71.3

**CODE & BACKEND**
- Stealth detection bugs fixed.

**INTERFACE & DESIGN**
- Crosshair indicator for targets with bounty added.

----

## 📦 1.71.2

**CODE & BACKEND**
- Some small bug fixes;
	- Crosshair config fix
	- Stealth detection fix in some situations

----

## 📦 1.71.0

**DEV NOTES**
- Due to many changes in the way saved variables are used, the previous database and options will be wiped.
  - Splash screen added going over changes when updating has been added to go over the details.

**CODE & BACKEND**
- LibRangeCheck removed as the crosshairs will no longer be changing opacity based on distance.
  - There are plans to include, as an options, an indicator or text to that shows you your the range of your target.
- Changed from using the event UNIT_HEALTH to UNIT_FREQUENCT_HEALTH due to blizzard side issues relating to that event for the time being.
  - Hundreds of UNIT_HEALTH events were being fired off for single heal events; very spammy.
- Multiple CPU and memory optimizations related to the crosshairs, as it seemed to be using more resources for what it was doing.
  - Significant increase in FPS, which got a little higher in beta due to arranging first, and optimizing second.
- Massive cleanup and optimizations resulting in removal of 2 files and a few functions without compromising data collection and updates.
- Saved variables that are saved between wow sessions has now been properly separated so that information on players can be shared between different characters.
  - This change was needed before kill on sight features are added, and also makes it easier to reset addon options without effecting player data.
- Added 20% more or so of other abilities to determine level of unknown players.
- Lots of additional fine tuning changes and fixes; too many to mention.
- Included a library to help with glowing specific elements but is currently unconnected or even loaded.
  - This will be connected shortly and will be used to highlight players with bounties, and later on; kill on sigh targets.

**INTERFACE & DESIGN**
- Splash screen added to be used on new version updates to go over changes.
- Overlay graphics has been added to Crosshairs.
  -- One overlay added at the moment to show you have a target with a Bounty.
- Crosshair image reworked to be a bit thinner. 
- Crosshairs have a new option to change the alpha/opacity their visibility.
- Fixed a few graphical issues related to Crosshairs.
- Removed rotating 'shine' ring from crosshairs
  - Additional overlays will take its spot to show information about the target.
- Title Bar flash when trying to move a pinned or locked window.


----

## 📦 1.71-beta7

**CODE & BACKEND**

- Moved all the sounds, fonts, textures, and icons to the new "Media" folder in the root, instead of having them all in root.
- Added a few dozen more spells and abilities to base estimated player levels off of.
- Fixed an issue where the selected stealth alerts sound chosen was not being saved.
- Improved the efficiency when obtaining and managing player data:
  - Less functions and variables being used, providing the same end result.
- Changed a number of things in how the Crosshairs were being dealt with:
  - For the time being, the fading of the crosshairs based on range has been removed, but plans to add a better indicator for ranges are already being looked into.
- Added a separate database for players that will be saved in your blizzard account settings folder.
  - This way other alts that are apart of the same b.net account can all share detected player data.
- Removed the xml files in favor of adding a few SetScripts in the Lua files.
- Fixed an issue with crosshairs not showing is the targets were switched very quickly from valid to invalid and back to valid target.

**INTERFACE & DESIGN**

- Removed Name and Guild crosshair options for the time being.
  - In order to do this properly there will need a few more changes and an almost complete replacement of the nameplate being used.
- Added more options in the Crosshair section:
  - Apply Optimal Nameplate CVar values:
    - This applies mostly default settings other than keeping targeted nameplates on the screen using radial clamping, and keeping all nameplate scales at 1 to help with smoother crosshair animations when doing from target to target.
- Crosshairs adjust so that they *should* now always be **BELOW** the in-game or any addon nameplate.
  - Previous versions has them sometimes showing in front, although not too often.
- Better and more consistent formatting in the options.
  - More info about options is now shown for the ones that are less obvious.

----

## 📦 1.71-beta6

**CODE & BACKEND**
- The `/wpvp config` command should now work properly in all situations; *(Blizzard bug workaround)*.
- Removed some unused media resources
- Normalized some sound files, but not all
  - *Having some be more quiet than others can be preferable for some people.*
- Reworked how bars are created so that there can be size and other customization added easily later on.
- Optimized Crosshair animations

**INTERFACE & DESIGN**
- Reverted back to not having bar texture selection for the time being
- Crosshair animation bug fixed when 'jumping' to lock onto the nameplate after initial movement animation if moving from another target.
- Added ability to set CVar options for nameplates for best results using Crosshairs.

----

## 📦 1.71-beta5

**DEV NOTES**
- A lot of options have been changed / added in this version to get things more organized and consistent on the backend.
  - There should be code in place to cover the changes, but if not please report the issue.
  - To revert back to default options you can use `/wpvp resetOptions`
    - Player data will remain untouched; only the addon options will be reset.
    - **This will reload the UI**

**INTERFACE & DESIGN**
- Created a new section in the options for the player bars.
  - Change texture option added.
    - *Some textures may not work as well as others when it comes to highlighting targeted player bars due to already being very bright.*
- Options Overhaul:
  - Formatting redone
  - New section 'Overview' added that shows addon tips and commands.
  - Specific options are now properly disabled if dependent options are not enabled.
  - New LagMode option added: Halt
    - This will halt all player data processing when below 10fps (for those extra laggy encounters).

**CODE & BACKEND**
- Fixed an issue where the error sound when attempting to drag a locked or pinned window wasn't being played if new player alerts were disabled.
- Minor code clean up and optimization.

----

## 📦 1.71-beta4b

**CODE & BACKEND**
- Fixed an issue where the error sound when attempting to drag a locked or pinned window wasn't being played if new player alerts were disabled.

----

## 📦 1.71-beta4

**CODE & BACKEND**
- Small fix to prevent errors related to trying to update player entries that no longer exist.
  
----

## 📦 1.71-beta3

**CODE & BACKEND**
- A few small bug fixes.
- Improved LagMode to be more optimized and  use less CPU.
  - There are more things to be done, but so far it seems to be working out pretty well.
- Optimized more code dealing with getting unit info, especially for in-combat situations where a lot of combat log and unit health events take place.
  - Added throttling updates to more areas for things that don't change as often; such as guild, level, race, etc.

**INTERFACE & DESIGN**
- Fixed a few issues that came from recent changes to the options.
- Added notifications when you try to resize a locked window.
  - Chat notifications for these events are now throttled so they don't spam chat when you keep clicking a locked or pinned window.
  
----

## 📦 1.71-beta2

**KNOWN ISSUES**
- The health bars seem to be a little jumpy sometimes; it's being looked into.
  - I think it may be due to periodic shields/absorbs/buffs/etc that change max health temporarily, but overall isn't a problem most of the time.

**DEV NOTES**
- Removed some small debug code that was left in 1.71-beta1; 

**MEDIA**
- Added **5** more sound files to choose from for new player/stealth alerts.
  - The default sound for new player detected has been changed, but you can change it to anything you want now anyway.
    - "weizPVP: Notice 2" was the old sound used if you're looking for it.
  - More alerts are planned down the road anyways for KoS, bounties, etc so I'll continue to look into other sounds to add that would work well for that.
  - If you have any suggestions and sources for good audio files, create an issue on Curse's weizPVP page and mark it as a feature request. *(Links would be awesome, but not needed.)*

**CODE & BACKEND**
- Added additional death detection for holy priests while using Spirit of Redemption.
  - Previously they were shown as alive while SoR was active; now they show as dead.
  - There may be an additional indicator added in later for that specific ability.

**INTERFACE & DESIGN**
- Polished up the options so that dependent options are greyed out if disabled
  - *(eg: If sound it disabled for new players, the selection for the sound file is disabled, etc).*
- Window lock and pin status is now shown in the status bar *(the bottom part of the window)*.
  - Error sound a notification added when you try to move the window when it is pinned or locked.
  - Fixed in issue where the window was jumping when locked when trying to resize the window.
  
----

## 📦 1.71-beta1

**DEV NOTES**
- I've been resetting my options and player database quite often due to test so I may not have noticed any issues from previous versions.
  - If you find any issues, you can try running the command: `/wpvp resetOptions` to wipe just the options, but not the player data.
  - If you still have problems you can wipe **ALL** your weizPVP settings and player data with `/wpvp resetall` which will make it as if you just installed it for the first time.
- If you want to help find bugs easy, feel free to use *debug mode*, which will detect **ALL** players; hostile as well as friendly.
  - You can toggle it back off by running the command again.
  - The status bar will also show 'DEBUG

**MEDIA**
- You are now able to change the sound file for player detected and stealth alert events
  - Additional sound files have been added to choose from; more in the works.
  - Sounds from other addons using the ShardMedia library will also be listed in the options, so there should be a lot to choose from!

**CODE & BACKEND**
- Several optimizations resulting in less CPU and memory usage.
- LagMode options adjusted for better reduction in processing when enabled and active.
- Improved the role detection further by adding in some more spellIDs and Auras.
- Roles are now updated as soon as it's known what it is.
  - *Previous versions only updated between sightings; now the player can change specs while on the list and you'll see the update once we have a know spell/ability to go off of.*
  - 360+ different spells, abilities, and auras are now being used to determine the role of the player.
    - This isn't 100% coverage of the roles, but it should is being determined quickly due to spell/ability rotations and auras gained.
    - If you want something added that isn't in yet that you noticed, just post an issue on the weizPVP page on Curse and I'll add it in.

----

## 📦 1.70 

**CODE & BACKEND**
- Many option issues fixed. Should now be setting and updating properly.
- Managing player data improved greatly; now using less resources and smarter sorting.
- A few improvements to role detection
  - Roles, when determined, are left active for a few minutes until checking for an update in order to reduce constant processing of data that doesn't change often. 
  - Roles are now saved in the DB and recalled when a player is detected again, using first the last known spec until otherwise determined.
- Improved dealing with dead players in a few more situations.

**INTERFACE & DESIGN**
- Resolved some issues related to the Crosshairs; should be working properly now.
  - *Blizzard seems to have changed some things related nameplates and as a result crosshairs were not working 100%.*
- Sorting methods polished and includes smarter updating and display of players on the list.
  - *Nothing drastic and most players probably won't even notice the change, but will work better when dealing with large groups.*
- Options are now more organized and better formatted.

----

## 📦 1.68

**CODE & BACKEND**
- Recreated the main combat log parsing function to be more efficient with determining information and using less processing and memory usage at the same time.
  - Significantly less processing during combat log events.
  - Optimized even further for players that are already listed.
  - Added LagMode optimizations, if enabled; this will stop guessing level estimations and other data-gathering functions to focus more on player's health and death events.
- Option changes:
  - LagMode is disabled by default.
  - Enabled in battlegrounds is now true by default
- Fixed one issue related to sorting dead players properly but there seems to be another issue with sorting them, but not all the time.
  - It's being looked into and it's a pretty minor bug overall.
- "LagMode" updates:
  - More places where LagMode disables info gathering methods that are more CPU intensive when LagMode is enabled and below FPS threshold (See options for details)

**INTERFACE & DESIGN**
- Crosshair updates
  - Crosshairs should now properly show _behind_ nameplates, as not to cover up the name or interfere with 3d party addons placing additional elements on the bar.
  - Optimized the animating of the crosshairs when switching targets and should also look cleaner and smoother.

----

## 📦 1.65

**CODE & BACKEND**
- Improved role detection by checking out player auras as well as spells and abilities used.

----

## 📦 1.6

**INTERFACE & DESIGN**
- Stealth Alert changes
  - Class color now added.
  - Ability name added.
  - More stealth abilities and items added to detection:
    - Greater Invisibility
    - Mass Invisibility
    - Shroud of Concealment
    - Stealthman 52
- Options Updated
  - Better grouping of options.
  - Enable in Arena option added.
  - Added stealth detection options for display and sound under Alerts section.
  - BETA section added for BETA Options.
    - LagMode options added to BETA section.
      - Enable toggle.
      - FPS threshold; Enables LagMode when below this level.

**CODE & BACKEND**
- Optimizations in a number of spots; Small CPU and memory reductions.
- Player info gathering optimized greatly; Large CPU reduction.
- DB Updates to get ready for Kill on Sight coming in 2.0.
- Combat Log and Health events/data collection changes:
  - Updated some methods of obtaining data.
  - Less CPU/mem usage.
- Library changes.
  - LibRangeCheck updated.
  - LibCLHealth removed.

----

## 📦 1.54

**CODE & BACKEND**
- Optimizations in the data gathering functions for detected players.
  - Mostly memory usage reductions.

----

## 📦 1.53

**CODE & BACKEND**
- Fixed another potential area where the player bars could flicker/swap with other players.
  - This fix made it easier to reduce even more processing by properly targeting single bars for updates.
  - This, along with other fixes have led to the lowest CPU and mem usage yet for weizPVP.
- Continued to optimize events and the processing of unit data to run even better in heavy PVP.

----

## 📦 1.52

**CODE & BACKEND**
- Fixed a few small bugs making player bars jump around a bit.
- More optimization here and there.

----

## 📦 1.51

**CODE & BACKEND**
- Some more optimizations;
  - List and player bar updates reduced further to be ran only when needed for visual updates.
  - Reduced running _some_ functions to gather player data when we already have it; we just update the timestamp/last seen info.
    - This will be an ongoing process. The addon is only getting faster at this point, even with new features added.
- Fixed a bug that was creating warnings while entering new zones.

**INTERFACE & DESIGN**
- Small adjustments to transition animation of the crosshairs.

----

## 📦 1.5

**CODE & BACKEND**
- Fixed some more bugs related to crosshairs not always showing up properly in a variety of situations.
- Big Database changes;
  - All previous options (like.. 5?) will be reset to the current default. (Last time this should happen)
  - Some optimizations made in the way it functions.
  - Better and more efficient structure.
- Multiple optimizations related to updating the player lists and bars; both data and the status bars.
  - CPU and Memory usage _looks_ to be down about 30-50% overall. More optimizations to come!

**INTERFACE & DESIGN**
- Crosshairs will now do a better job of staying on a nameplate after reaching it.
  - This also turned out to be a pretty nice optimization as well.

**FUNCTIONALITY**
- Slash commands have been simplified more since more and more are going to WoW's option menu.
- Fixed some weird issues with the crosshair acting oddly via options or in BGs.
- Fixed problems with when toggle BGs on or off while in them.

----

## 📦 1.22

**CODE & BACKEND**
- Fixed a number of bugs while looking into sorting issues.
  - Sorting issues out of combat seem resolved.

----

## 📦 1.2

**INTERFACE & DESIGN**
- Adjusted Crosshair some animations and textures.

**CODE & BACKEND**
- Cleaned up assets and old comments for release.
- Optimized some code dealing with list management.

----

## 📦 1.13

**INTERFACE & DESIGN**
- Minor changes to bar textures.

**FUNCTIONALITY**
- Addressed Issue #13 on Curseforge: Pinning options are now synced across methods (slash, right click, interface options).
- Slash commands for lock and pin now toggle on/off.
  - The 'unpin' and 'unlock' slash commands removed as there is one command to toggle them.

----

## 📦 1.12

**INTERFACE & DESIGN**
- Added an indicator to the player bars to show your target.
- Added small animation effects to min/max button.
- Resizing the main window will now snap at heights that show only complete bars. No more cutoff bars; Perfection.
- Clamping of the window to the screen has been improved. No part of the window should be able to be moved off-screen anymore.
- Scrolling now correctly scrolls in even increments based on the size and spacing of the player bars.
- Right-Clicking on the title bar at the top of the addon addon will now toggle the 'pin' option, and will output in chat to let you know as well.
- Window location and size is now saved between sessions.

**FUNCTIONALITY**

- The addon is now disabled in all instances (even BGs and Arenas). This may change later, but in order to have it work properly a decent big of work is required as they use additional API calls specific to the instance.

